<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Spark on MyBinder</title>
    <meta name="description" content="Slides for the Course Big Data Tools for Advanced Professionals hands-on exercise with Spark on mybinder">
    <meta name="author" content="Ole Mussmann">

    <link rel="icon" type="image/x-icon" href="./files/favicon-32x32.png">

    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">

    <!-- theme -->
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">
    <link rel="stylesheet" href="dist/theme/escience_5.1.0.css" id="theme">

    <!-- fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Assistant:wght@200..800&family=Fira+Code:wght@300..700&family=Nunito:ital,wght@0,200..1000;1,200..1000&display=swap">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

    <!-- Load jQuery -->
    <script
      src="https://code.jquery.com/jquery-3.4.1.min.js"
      integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
      crossorigin="anonymous"></script>
    <script src="http://localhost:35729/livereload.js"></script>

  </head>
  <body>
    <div class="reveal">
      <div class="slides">

        <section data-state="blue_overlay yellow_flag yellow_strip purple_half_circle_bottom purple_blob right_e_top" data-background-video="./files/Mood video Homepage 2.mp4" data-background-video-loop data-background-video-muted="true">
          <!-- https://pixabay.com/users/ollis_picture-3313651 under CC0 -->
          <img style="position: absolute; top: 0px; left: 50%; transform: translate(-100%, 0%); height:5vh;" data-src="./files/logo.png">
          <img style="position: absolute; top: 0px; left: 50%; transform: translate(+100%, 0%); height:5vh; background: white; opacity: 0.7; border-radius: 4px; padding: 5px;" data-src="./files/cbs-brand.svg"-->
          <img style="position: absolute; top: 0px; left: 50%; transform: translate(+100%, 0%); height:5vh; padding: 5px;" data-src="./files/cbs-brand.svg"-->
          <h2><br><br>Hands-on with Spark</h2>
          <h3>On MyBinder</h3>
          <h5><br><a href="mailto:o.mussmann@esciencecenter.nl">Bjoern Ole Mussmann</a><br>The Netherlands eScience Center</h5>
        </section>

        <section data-state="standard" data-background="./files/checklist-2589418_1920.jpg" data-markdown>
          <!-- https://pixabay.com/photos/checklist-goals-box-notebook-pen-2589418/ -->
          <textarea data-template>

            ## Table of Contents

            - [Overview Spark in the Cloud](#/cloud)
            - [Overview MyBinder](#/binder)
            - [MapReduce with Jane Austen 📖](#/mapreduce)
            - [Analyzing the World of Rrrrrr 🏴‍☠️🦜](#/r)
            - [Summary](#/summary)

          </textarea>
        </section>

        <section>
          <section id="cloud" data-state="standard 3" data-background="./files/sky-414199_1920.jpg" data-markdown>
            <!-- Image by <a href="https://pixabay.com/users/giografiche-377204/?utm_source=link-attribution&utm_medium=referral&utm_campaign=image&utm_content=414199">giografiche</a> from <a href="https://pixabay.com//?utm_source=link-attribution&utm_medium=referral&utm_campaign=image&utm_content=414199">Pixabay</a> -->
            <textarea data-template>

              # Spark in the Cloud

              ---

              <!-- .slide: data-state="standard 8" data-background="./files/sky-414199_1920.jpg" -->

              ## Cloud Vendors Offering Spark

              - Amazon <a href="https://aws.amazon.com/what-is/apache-spark/">aws.amazon.com/what-is/apache-spark</a>
              - databricks <a href="https://www.databricks.com/spark/about">databricks.com/spark/about</a>
              - IBM <a href="https://www.ibm.com/products/analytics-engine">ibm.com/products/analytics-engine</a>
              - cloudera <a href="https://www.cloudera.com/products/open-source/apache-hadoop/apache-spark.html">cloudera.com/products/open-source/apache-hadoop/apache-spark.html</a>
              - Google <a href="https://cloud.google.com/dataproc">cloud.google.com/dataproc</a>
              - ... and many more

              But none of them for free anymore 😕 <!-- .element: class="fragment" -->

              <p class="fragment"><a href="https://mybinder.org">mybinder.org</a> to the rescue!</p>

            </textarea>
          </section>
        </section>

        <section>
          <section id="binder" data-state="blue_overlay yellow_flag logo" data-background="./files/calendar-428290_1920.jpg" data-markdown>
            <textarea data-template>

              # Introduction <a href="https://mybinder.org">mybinder.org</a>

              ---

              <!-- .slide: data-state="blue_overlay yellow_flag logo" data-background="./files/calendar-428290_1920.jpg" -->
              <!-- https://pixabay.com/photos/kids-bike-bike-bicycle-stabilisers-6365053/ -->

              ## My What Now? MyBinder!

              - Free notebooks in the cloud
              - Launch directly from your git repo
              - Define your environment by
              - `requirement.txt`
              - `install.R`
              - `Pipfile`
              - `Dockerfile`
              - `default.nix`
              - ... and many more
              - Donation based


            </textarea>
          </section>
        </section>

        <section>
          <section id="mapreduce" data-state="purple_overlay logo yellow_flag" data-background="./files/compass-2946959_1920.jpg" data-markdown>
            <textarea data-template>
              <!-- https://snl.no/Jane_Austen -->

              # MapReduce
              ## with Pride <span class="fragment" data-fragment-index="1">and Prejudice</span>

              <div class="fragment" style="width: 70%; float: left; text-align: left;">
                Once upon a time...<br><br>
                An avid collector of Jane Austen works dropped their precious collection of 10 books of "Pride and Prejudice". The impact changed <i>one</i> word among all those books. Which word was affected?
              </div>

              <img class="fragment" data-fragment-index="1" style="width: 25%; float: right;" src="./files/standard_compressed_Jane_Austen_coloured_version.jpg"/>


              ---

              <!-- .slide: data-state="purple_overlay logo yellow_flag" data-background="./files/compass-2946959_1920.jpg" -->
              <!-- https://pixabay.com/photos/compass-map-direction-degrees-2946959/ -->

              ## Action!

              <!--a href="https://mybinder.org/v2/gh/OleMussmann/pyspark-binder-environment.git/HEAD"><img style="width: 10vw; padding: 0; margin: 0;" src="https://mybinder.org/badge_logo.svg"></a-->
              <!--a href="https://mybinder.org/v2/gh/OleMussmann/pyspark-binder-environment/main?labpath=word_count.ipynb"><img style="width: 10vw; padding: 0; margin: 0;" src="https://mybinder.org/badge_logo.svg"></a-->
              <a href="https://mybinder.org/v2/gh/OleMussmann/pyspark-binder-environment.git/HEAD?labpath=word_count.ipynb"><img style="width: 10vw; padding: 0; margin: 0;" src="https://mybinder.org/badge_logo.svg"></a>

              <pre style="margin-top: 0; width: fit-content; background: #555; margin: 2em auto;"><code data-trim data-noescape style="font-size: medium; padding: 1em 2em;">ACCESS_KEY <span style="background-color: #884; border-radius: .5ex; padding: .2ex;">ACC</span>: AKIAQ4TXNQJHTDBCH44V
SECRET_KEY <span style="background-color: #884; border-radius: .5ex; padding: .2ex;">SEC</span>: JknqLzxb/XLXX4+pwQiAivNc406xKl1jmJ18Bu84
              </code></pre>

              <img style="width: 23%; float: left; padding: 0; margin: 0;" src="./files/hacker_cat.svg"/>
              <div style="width: 77%; float: right;">
                Edit the notebook and find out which word was changed.
                <br>
                <br>
                <span class="fragment" style="text-align: center;"> Bonus: In which line number? </span>
              </div>

            </textarea>
          </section>
        </section>

        <section>
          <section id="r" data-state="black_overlay 6 yellow_flag logo" data-background="./files/ship-2202910_1280.jpg" data-markdown>
            <textarea data-template>

              # Analyzing the world of Rrrrrr 🏴‍☠️🦜

              ## R package popularity contest <!-- .element: class="fragment" -->

              ---

              <!-- .slide: data-state="black_overlay 6 yellow_flag logo" data-background="./files/ship-2202910_1280.jpg" -->
              <!-- https://pixabay.com/photos/ship-strom-sea-night-fantasy-red-2202910/ -->

              # Action!

              <a href="https://mybinder.org/v2/gh/OleMussmann/pyspark-binder-environment.git/HEAD?labpath=r_packages.ipynb"><img style="width: 10vw; padding: 0; margin: 0;" src="https://mybinder.org/badge_logo.svg"></a>

              <img style="width: 23%; float: left; padding: 0; margin: 0;" src="./files/hacker_cat.svg"/>
              <div style="width: 77%; float: right;">
                <br>
                Which are Top 10 downloads from last Friday?
                <br>
                <em class="fragment">Edit the URL (x2!) to get the correct file.</em>
                <br>
                <span class="fragment">(Skip the intermezzos if they take too long.)</span>
                <br>
                <br>
                <span class="fragment" style="text-align: center;"> Bonus: Top 10 for last Month? Last year? </span>
              </div>

            </textarea>
          </section>
        </section>

        <section id="summary" data-state="black_overlay 2 yellow_flag logo" data-background="./files/note-pad-1215425_1920.jpg">
          <!-- https://pixabay.com/illustrations/note-pad-pen-coffee-cup-plant-1215425/ -->

          <div style="transform: rotate(-5deg); width: 82%; float: left;">
            <h2 style="color: black;">Summary</h2>
            <p style="color: black;">We have practiced:</p>
            <ul style="color: black; width: 38%; float: right;">
              <li>Filtering</li>
              <li>Sorting</li>
              <li>Joins</li>
              <li>Plotting</li>
            </ul>
            <ul style="color: black; width: 38%; float: right;">
              <li>MapReduce</li>
              <li>Data cleaning</li>
              <li>Set operations</li>
              <li>Counting</li>
            </ul>
          </div>
        </section>

      </div>
    </div>

    <script src="dist/reveal.js"></script>

    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/math/math.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/search/search.js"></script>
    <script src="plugin/zoom/zoom.js"></script>
    <!--
    <script src="reveal.js/4.3.1/reveal.js-plugins/menu/menu.js"></script>
    -->

    <script src="dist/theme/escience_5.1.0.js"></script>

    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Automatically activate the scroll view when we the viewport falls
        // below the given width.
        scrollActivationWidth: 0,  // disabled

        // Force the scrollbar to remain visible
        scrollProgress: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>
  </body>
</html>
